﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

//code-behind (w MVVM to jest czyste zło)

namespace KoloryWPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        bool czyUruchamiaćMetodęZdarzeniowąSuwaków = false;

        public MainWindow()
        {
            InitializeComponent();

            kolorProstokąta = CzytajUstawienia();
            sliderR.Value = kolorProstokąta.R;
            sliderG.Value = kolorProstokąta.G;
            sliderB.Value = kolorProstokąta.B;
            czyUruchamiaćMetodęZdarzeniowąSuwaków = true;
        }

        private Color kolorProstokąta
        {
            get
            {
                return (rectangle.Fill as SolidColorBrush).Color;
            }
            set
            {
                (rectangle.Fill as SolidColorBrush).Color = value;
            }
        }

        private void Slider_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            if(czyUruchamiaćMetodęZdarzeniowąSuwaków)
                kolorProstokąta = Color.FromRgb((byte)sliderR.Value, (byte)sliderG.Value, (byte)sliderB.Value);
        }

        private static void ZapiszUstawienia(Color kolor)
        {
            Properties.Settings.Default.Kolor = kolor;
            Properties.Settings.Default.Save();
        }

        private static Color CzytajUstawienia()
        {
            return Properties.Settings.Default.Kolor;
        }

        private void Window_Closed(object sender, EventArgs e)
        {
            ZapiszUstawienia(kolorProstokąta);
        }
    }
}
